Description

The code handling the BOOST libraries in configure is an "unholy mess".

If the user specifies no BOOST option then configure tries to search for BOOST.

I am now inclined to simplify this:

if no BOOST option is specified then compilation is without BOOST

new configure option --with-boost which assumes a standard system installation.

the old option to specify where the BOOST libraries are remains (in case not a standard system installation)

This new approach should allow me to simplify the configure script... I hope!

Related issues:

Related to CoCoA-5 - Bug #1695: boost-find-lib.sh Closed 16 Aug 2022

Related to CoCoA-5 - Design #1696: Which BOOST libs are actually needed? Closed 18 Aug 2022

Related to CoCoALib - Support #1700: boost_1_80_0 Closed 14 Oct 2022

Related to CoCoALib - Feature #1360: configure script: add flags for "only co... Closed 01 Nov 2019

History

#1 - 18 Aug 2022 14:38 - John Abbott

- Related to Bug #1695: boost-find-lib.sh added

#2 - 18 Aug 2022 14:38 - John Abbott

- Related to Design #1696: Which BOOST libs are actually needed? added

#3 - 22 Aug 2022 16:59 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

In a sense there is no difference between --with-boost  and  --also-build-CoCoA5

(except that one is clearly boolean, while the other can specify where to find the lib)

Mmmm.

#4 - 15 Sep 2022 14:55 - John Abbott

- Assignee set to John Abbott

- % Done changed from 10 to 50

After discussions with Anna, we will try a new configure option --only-cocoalib (which supplants --no-boost).

If --only-cocoalib is not specified then BOOST is assumed to be system-wide installed unless --with-boost=XXX is specified.

Specifying --only-cocoalib and a BOOST or READLINE option will give an error (currently)

[maybe a warning would be better?  This would allow easier testing perhaps?]
I have modified configure; it seems fine on my Linux box.

#5 - 14 Oct 2022 10:18 - Anna Maria Bigatti

- Related to Support #1700: boost_1_80_0 added

#6 - 14 Oct 2022 10:26 - Anna Maria Bigatti

I would change --with-boost with --with-boost-hdrs or --with-boost-incdir (or similar) to highlight that for boost we point to the include dir, instead of

passing the library file (as it is for all other external libraries)

"--with-boost-hdrs=/Users/XXXXXXXXXXX/boost_1_80_0/include/" 

 

[I use a minimal personal installation of boost for experimental purposes]

#7 - 14 Oct 2022 10:31 - Anna Maria Bigatti

It seems that -Bstatic works only for linux

CoCoAInterpreter: linking everything together

ld: unknown option: -Bstatic

clang: error: linker command failed with exit code 1 (use -v to see invocation)

make[2]: *** [CoCoAInterpreter] Error 1

I changed BOOST_LDLIBS=-Wl,-Bstatic -lboost_filesystem  -Wl,-Bdynamic into BOOST_LDLIBS=-lboost_filesystem and my compilation goes a little

further

#8 - 23 Nov 2022 17:25 - John Abbott

- Status changed from In Progress to Feedback

- % Done changed from 50 to 90

- Estimated time set to 2.99 h

Anna: I think this issue no longer exists with the new/revised configuration system (scripts).

Correct?  If so, please close.

#9 - 23 Nov 2022 17:33 - John Abbott

- Related to Feature #1360: configure script: add flags for "only cocoalib" or "both cocoalib and cocoa5" (for boost) added

#10 - 14 Dec 2022 22:33 - John Abbott

- Status changed from Feedback to Closed
- % Done changed from 90 to 100

- Estimated time changed from 2.99 h to 4.49 h

I have made a major revision to doc/txt/ExternalLibs-BOOST.txt

I think it is now up-to-date.

Closing.
